## robotraconteur-companion 0.4.2

=== CMakeLists.txt ===
if((CMAKE_VERSION VERSION_GREATER 3.12 OR CMAKE_VERSION VERSION_EQUAL 3.12))
    cmake_minimum_required(VERSION 3.12...3.31)
else()
    cmake_minimum_required(VERSION 3.5)
endif()
project(RobotRaconteurCompanion VERSION 0.4.2 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 11)

if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/cmake_config_options.cmake)
    include(${CMAKE_CURRENT_LIST_DIR}/cmake_config_options.cmake)
endif()

find_package(RobotRaconteur 0.17.0 REQUIRED)
find_package(yaml-cpp REQUIRED)
find_package(Eigen3 3.3 REQUIRED NO_MODULE)
find_package(OpenCV)

if(NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/robdef/group1")
    message(FATAL_ERROR "RobotRaconteurCompanion must use git clone --recursive, currently missing robdef files")
endif()

set(RR_SERVICE_NAMES_GROUP1
    com.robotraconteur.action
    com.robotraconteur.actuator
    com.robotraconteur.bignum
    com.robotraconteur.color
    com.robotraconteur.datatype
    com.robotraconteur.datetime.clock
    com.robotraconteur.datetime
    com.robotraconteur.device.clock
    com.robotraconteur.device.isoch
    com.robotraconteur.device
    com.robotraconteur.eventlog
    com.robotraconteur.fiducial
    com.robotraconteur.geometry
    com.robotraconteur.geometry.shapes
    com.robotraconteur.geometryf
    com.robotraconteur.geometryi
    com.robotraconteur.gps
    com.robotraconteur.hid.joystick
    com.robotraconteur.identifier
    com.robotraconteur.image
    com.robotraconteur.imaging.camerainfo
    com.robotraconteur.imaging
    com.robotraconteur.imu
    com.robotraconteur.laserscan
    com.robotraconteur.laserscanner
    com.robotraconteur.lighting
    com.robotraconteur.objectrecognition
    com.robotraconteur.octree
    com.robotraconteur.param
    com.robotraconteur.pid
    com.robotraconteur.pointcloud
    com.robotraconteur.pointcloud.sensor
    com.robotraconteur.resource
    com.robotraconteur.resource.device
    com.robotraconteur.robotics.joints
    com.robotraconteur.robotics.payload
    com.robotraconteur.robotics.robot
    com.robotraconteur.robotics.tool
    com.robotraconteur.robotics.trajectory
    com.robotraconteur.sensor
    com.robotraconteur.sensordata
    com.robotraconteur.servo
    com.robotraconteur.signal
    com.robotraconteur.units
    com.robotraconteur.uuid)

foreach(f1 IN LISTS RR_SERVICE_NAMES_GROUP1)
    list(APPEND RR_INSTALLED_ROBDEF "$\{RobotRaconteur_STANDARD_ROBDEF_ROOT_DIR\}/group1/${f1}.robdef")
    list(APPEND RR_ROBDEF_SOURCE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/robdef/group1/${f1}.robdef")
endforeach()

set(RR_SERVICE_NAMES ${RR_SERVICE_NAMES_GROUP1})

set(RR_INSTALLED_ROBDEF_DIRS "$\{RobotRaconteur_STANDARD_ROBDEF_ROOT_DIR\}/group1")

robotraconteur_generate_thunk(
    RR_THUNK_SRCS
    RR_THUNK_HDRS
    ${RR_ROBDEF_SOURCE_FILES}
    OUTDIR
    ${CMAKE_CURRENT_BINARY_DIR}/robdef_gen
    CPP_EXTRA_INCLUDE
    "RobotRaconteurCompanion/StdRobDef/StdRobDef_Macros.h")

add_library(
    RobotRaconteurCompanion
    ${RR_THUNK_SRCS}
    ${RR_THUNK_HDRS}
    src/StdRobDefAll.cpp
    src/yaml_loader_enums.cpp
    src/LocalIdentifiersManager.cpp
    src/UuidUtil.cpp
    src/yaml_loader_impl.cpp
    src/EigenConverters.cpp
    src/AttributesUtil.cpp
    src/DateTimeUtil.cpp
    src/IdentifierUtil.cpp
    src/InfoFileLoader.cpp
    src/DeviceConnector.cpp)
set_target_properties(RobotRaconteurCompanion PROPERTIES PREFIX lib)

target_link_libraries(RobotRaconteurCompanion PUBLIC RobotRaconteurCore Eigen3::Eigen yaml-cpp)
target_include_directories(
    RobotRaconteurCompanion
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/robdef_gen/> $<INSTALL_INTERFACE:include>
           $<INSTALL_INTERFACE:include/RobotRaconteurCompanion/StdRobDef/group1>)

if(CMAKE_COMPILER_IS_GNUCXX)
    target_compile_options(RobotRaconteurCompanion PRIVATE "-fPIC")
endif()

if(MSVC)
    target_compile_options(RobotRaconteurCompanion PRIVATE "/wd4251" "/wd4275" "/bigobj")
endif()

if(BUILD_SHARED_LIBS AND WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    target_compile_definitions(
        RobotRaconteurCompanion
        PRIVATE ROBOTRACONTEUR_COMPANION_STDROBDEF_EXPORTS ROBOTRACONTEUR_COMPANION_INFOPARSER_EXPORTS
                ROBOTRACONTEUR_COMPANION_UTIL_EXPORTS
        INTERFACE ROBOTRACONTEUR_COMPANION_STDROBDEF_IMPORTS ROBOTRACONTEUR_COMPANION_INFOPARSER_IMPORTS
                  ROBOTRACONTEUR_COMPANION_UTIL_IMPORTS)
endif()

if(WIN32)
    if(BUILD_SHARED_LIBS)
        target_link_libraries(RobotRaconteurCompanion PRIVATE Bcrypt.lib)
    else()
        target_link_libraries(RobotRaconteurCompanion PUBLIC Bcrypt.lib)
    endif()
endif()

option(ROBOTRACONTEUR_COMPANION_SOVERSION_MAJOR_ONLY "Only include major version in SOVERSION" OFF)

if(ROBOTRACONTEUR_COMPANION_SOVERSION_MAJOR_ONLY)
    if(PROJECT_VERSION_MAJOR VERSION_EQUAL 0)
        # If major version is 0, we use the major and minor version as the SOVERSION
        set(_ROBOTRACONTEUR_COMPANION_SOVERSION "0.${PROJECT_VERSION_MINOR}")
    else()
        set(_ROBOTRACONTEUR_COMPANION_SOVERSION "${PROJECT_VERSION_MAJOR}")
    endif()
else()
    set(_ROBOTRACONTEUR_COMPANION_SOVERSION
        "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
endif()
set_target_properties(RobotRaconteurCompanion PROPERTIES VERSION ${PROJECT_VERSION}
                                                         SOVERSION ${_ROBOTRACONTEUR_COMPANION_SOVERSION})

export(TARGETS RobotRaconteurCompanion FILE ${CMAKE_BINARY_DIR}/RobotRaconteurCompanionTargets.cmake)

include(GNUInstallDirs)

include(CMakePackageConfigHelpers)
configure_package_config_file(
    "cmake/Config.cmake.in" "${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}"
    PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_BINDIR CMAKE_INSTALL_DATADIR)

write_basic_package_version_file("${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Version.cmake" COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})
install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})

install(
    DIRECTORY robdef/
    DESTINATION ${CMAKE_INSTALL_DATADIR}/robotraconteur/robdef/standard_robdef/
    FILES_MATCHING
    PATTERN "*.robdef")

install(
    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    FILES_MATCHING
    PATTERN "*.h*")

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/robdef_gen/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/RobotRaconteurCompanion/StdRobDef/group1
    FILES_MATCHING
    PATTERN "*.h*")

install(
    TARGETS RobotRaconteurCompanion
    EXPORT RobotRaconteurCompanionTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(EXPORT RobotRaconteurCompanionTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})

include(CTest)

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

find_package(Doxygen)
option(BUILD_DOCUMENTATION "Build documentation using Doxygen" ${DOXYGEN_FOUND})

# https://p5r.uk/blog/2014/cmake-doxygen.html
if(BUILD_DOCUMENTATION)
    if(NOT DOXYGEN_FOUND)
        message(FATAL_ERROR "Doxygen is needed to build the documentation")
    endif()

    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/docs)
    configure_file(${CMAKE_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    add_custom_target(
        RobotRaconteurCompanion_doc
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen"
        VERBATIM)
endif()

file(STRINGS "${CMAKE_SOURCE_DIR}/package.xml" ROS_PKG_VERSION_1 REGEX "<version>[0-9]+\\.[0-9]+\\.[0-9]+</version>")
string(REGEX REPLACE "<version>([0-9]+\\.[0-9]+\\.[0-9]+)</version>" "\\1" ROS_PKG_VERSION ${ROS_PKG_VERSION_1})
string(STRIP ${ROS_PKG_VERSION} ROS_PKG_VERSION)
if(NOT ("${ROS_PKG_VERSION}" VERSION_EQUAL "${PROJECT_VERSION}"))
    message(FATAL_ERROR "Found ROS package version |${ROS_PKG_VERSION}| mismatch |${PROJECT_VERSION}|")
endif()

list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.git/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.vs/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.vscode/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.github/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.gitlab/")
# list(APPEND CPACK_SOURCE_IGNORE_FILES "/build/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "^${CMAKE_SOURCE_DIR}/build[\\\\-_/]")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.cache")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.gitignore")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.gitmodules")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.travis.yml")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.clang-format")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.clang-tidy")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.cmake-format.yaml")

set(CPACK_SOURCE_TBZ2 OFF CACHE BOOL "" FORCE)
set(CPACK_SOURCE_TXZ OFF CACHE BOOL "" FORCE)
set(CPACK_SOURCE_TZ OFF CACHE BOOL "" FORCE)
if(NOT WIN32)
    set(CPACK_SOURCE_TGZ ON CACHE BOOL "" FORCE)
endif()
set(CPACK_SOURCE_ZIP ON CACHE BOOL "" FORCE)

include(CPack)

=== test/CMakeLists.txt ===
if(ROBOTRACONTEUR_COMPANION_DIST_TEST_BUILD)
    if((CMAKE_VERSION VERSION_GREATER 3.12 OR CMAKE_VERSION VERSION_EQUAL 3.12))
        cmake_minimum_required(VERSION 3.12...3.31)
    else()
        cmake_minimum_required(VERSION 3.5)
    endif()
    project(RobotRaconteurCompanion_Dist_Test VERSION LANGUAGES CXX)

    find_package(RobotRaconteur REQUIRED)
    find_package(RobotRaconteurCompanion REQUIRED)
    include(CTest)
endif()

find_package(GTest REQUIRED)
find_package(OpenCV REQUIRED)

include_directories(${RobotRaconteur_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/../robdef_gen)
add_executable(test_robdef_gen test_robdef_gen.cpp)
target_link_libraries(test_robdef_gen RobotRaconteurCompanion RobotRaconteurCore)
add_executable(test_infoparser test_infoparser.cpp)
target_link_libraries(test_infoparser RobotRaconteurCompanion RobotRaconteurCore yaml-cpp)
if(MSVC)
    target_compile_options(test_infoparser PRIVATE "/wd4251" "/wd4275" "/bigobj")
endif()
add_executable(test_robotinfo_parser test_robotinfo_parser.cpp)
target_link_libraries(test_robotinfo_parser RobotRaconteurCompanion RobotRaconteurCore yaml-cpp)

find_package(Eigen3 3.3 REQUIRED NO_MODULE)
add_executable(test_eigen_converters test_eigen_converters.cpp)
target_link_libraries(test_eigen_converters RobotRaconteurCompanion RobotRaconteurCore Eigen3::Eigen GTest::Main)

add_test(NAME test_robdef_gen COMMAND test_robdef_gen)
add_test(NAME test_eigen_converters COMMAND test_eigen_converters)

if(NOT ROBOTRACONTEUR_COMPANION_DIST_TEST_BUILD)
    robotraconteur_generate_thunk(
        TASK_GEN_RR_SRC TASK_GEN_RR_HDR experimental.testing.companion.test_task_generator.robdef AUTO_IMPORT
        INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/robdef/group1)
else()
    robotraconteur_generate_thunk(
        TASK_GEN_RR_SRC TASK_GEN_RR_HDR experimental.testing.companion.test_task_generator.robdef AUTO_IMPORT
        INCLUDE_DIRS ${RobotRaconteur_STANDARD_ROBDEF_DIRS})
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(test_task_generator test_task_generator.cpp ${TASK_GEN_RR_SRC} ${TASK_GEN_RR_HDR})
target_link_libraries(test_task_generator RobotRaconteurCompanion RobotRaconteurCore GTest::Main)
add_test(NAME test_task_generator COMMAND test_task_generator)

add_executable(test_device_connector test_device_connector.cpp)
target_link_libraries(test_device_connector RobotRaconteurCompanion RobotRaconteurCore GTest::Main)
add_test(NAME test_device_connector COMMAND test_device_connector WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

if(OpenCV_VERSION VERSION_EQUAL 3.0.0 OR OpenCV_VERSION VERSION_GREATER 3.0.0)

    add_executable(test_image_util test_image_util.cpp ${TASK_GEN_RR_SRC} ${TASK_GEN_RR_HDR})
    target_link_libraries(
        test_image_util
        RobotRaconteurCompanion
        RobotRaconteurCore
        GTest::Main
        opencv_core
        opencv_imgproc
        opencv_imgcodecs)
    add_test(NAME test_image_util COMMAND test_image_util)
else()
    add_executable(test_image_util test_image_util.cpp ${TASK_GEN_RR_SRC} ${TASK_GEN_RR_HDR})
    target_link_libraries(test_image_util RobotRaconteurCompanion RobotRaconteurCore GTest::Main opencv_core
                          opencv_imgproc)
    add_test(NAME test_image_util COMMAND test_image_util)
endif()

=== debian/changelog ===
robotraconteur-companion (0.4.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1110150)

 -- John Wason <wason@wasontech.com>  Thu, 31 Jul 2025 22:13:13 +0000

=== debian/control ===
Source: robotraconteur-companion
Section: libs
Priority: optional
Maintainer: John Wason <wason@wasontech.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-regex-dev,
               libboost-chrono-dev,
               libboost-atomic-dev,
               libboost-random-dev,
               libboost-program-options-dev,
               libboost-dev,
               libssl-dev,
               librobotraconteur-dev,
               libgtest-dev,
               libyaml-cpp-dev,
               libeigen3-dev,
               libopencv-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/johnwason/robotraconteur-companion
Vcs-Git: https://salsa.debian.org/johnwason/robotraconteur-companion.git
Homepage: https://github.com/robotraconteur/robotraconteur_companion

Package: librobotraconteurcompanion0.4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Companion C++ library for Robot Raconteur runtime
 The Robot Raconteur C++ Companion library provides additional support
 for standardized types and services in Robot Raconteur along with
 other useful utilities. This package provides run-time library
 of robotraconteur-companion.

Package: librobotraconteur-companion-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: librobotraconteurcompanion0.4 (= ${binary:Version}),
         librobotraconteur-dev,
         ${misc:Depends},
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-thread-dev,
         libboost-regex-dev,
         libboost-chrono-dev,
         libboost-atomic-dev,
         libboost-random-dev,
         libboost-program-options-dev,
         libboost-dev,
         libyaml-cpp-dev,
         libeigen3-dev,
         libopencv-dev
Description: Companion C++ library for Robot Raconteur development files
 The Robot Raconteur C++ Companion library provides additional support
 for standardized types and services in Robot Raconteur along with
 other useful utilities. This package provides development files of
 robotraconteur-companion.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

CPPFLAGS :=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   :=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS :=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  :=$(shell dpkg-buildflags --get LDFLAGS)

export DEB_HOST_MULTIARCH CPPFLAGS CFLAGS CXXFLAGS LDFLAGS

COMMON_CMAKE_FLAGS = \
    -DCMAKE_INSTALL_PREFIX=/usr \
	-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
    -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
    -DBUILD_TESTING=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON) \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_SHARED_LIBS=ON \
    -DROBOTRACONTEUR_COMPANION_SOVERSION_MAJOR_ONLY=ON \
    -DCMAKE_SKIP_RPATH=ON \
    -DCMAKE_GTEST_DISCOVER_TESTS_DISCOVERY_MODE=PRE_TEST

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CMAKE_FLAGS)

override_dh_auto_test:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$$LD_LIBRARY_PATH dh_auto_test --no-parallel

override_dh_auto_install:
	dh_auto_install
	find debian/tmp/usr/share/robotraconteur/robdef -type d -empty -delete || true

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d[\d\.]*)\/RobotRaconteurCompanion-([\d\.]+)-Source\.tar\.gz/robotraconteur-$2.tar.gz/ \
https://github.com/robotraconteur/robotraconteur_companion/tags .*/v([\d\.]+)
